'use strict';

module.exports = function() {

    return this
            .title('Benchmarks')
            .helpful()
            .arg()
                .name('benchmarks')
                .title('List of benchmarks to run')
                .arr()
                .end()
            .opt()
                .name('treeish-list')
                .title('List of revisions to compare (git treeish)')
                .short('r').long('revision')
                .arr()
                .end()
            .opt()
                .name('no-wc')
                .title('Run benchmarks without using working copy, use only specified revisions')
                .short('w').long('no-wc')
                .flag()
                .end()
            .opt()
                .name('rerun')
                .title('Reuse previously checked out and made revisions, run benchmarks only')
                .long('rerun')
                .flag()
                .end()
            .opt()
                .name('techs')
                .title('Techs to run tests for')
                .short('t').long('techs')
                .arr()
                .end()
            .opt()
                .name('rme')
                .title('Delta for RME')
                .long('rme')
                .end()
            .opt()
                .name('delay')
                .title('Delay between benchmarks')
                .short('d').long('delay')
                .end()
            .act(function(opts,args) {
                return require('../bench')(opts, args).start();
            })
        .end();
};
